"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeAndAddJsonConfig = exports.modifyJsonConfig = void 0;
const loadExistingFile_1 = require("./loadExistingFile");
const writeAndAddFile_1 = require("./writeAndAddFile");
const modifyJsonConfig = (config, file, modify) => __awaiter(void 0, void 0, void 0, function* () {
    const sourceFile = yield (0, loadExistingFile_1.loadExistingFile)(config, file);
    if (!sourceFile) {
        throw new Error(`File ${file} not found`);
    }
    const sourceObject = JSON.parse(sourceFile);
    if (typeof sourceObject !== "object" || sourceObject === null) {
        throw new Error(`File ${file} does not contain a JSON object`);
    }
    const modified = yield modify(sourceObject);
    yield (0, writeAndAddFile_1.writeAndAddFile)(config, file, JSON.stringify(modified, null, 2));
});
exports.modifyJsonConfig = modifyJsonConfig;
const writeAndAddJsonConfig = (config, file, content) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, writeAndAddFile_1.writeAndAddFile)(config, file, JSON.stringify(content, null, 2));
});
exports.writeAndAddJsonConfig = writeAndAddJsonConfig;
