import { PackageManager } from "install-pnpm-package/dist/detectPackageManager";
export declare type Logger = {
    logMessage: (message: string, options: {
        type?: "info" | "error" | "warning" | "success";
    }) => void;
    logState: (id: string, options: {
        text?: string;
        state?: "pending" | "active" | "completed" | "failed";
    }) => void;
};
export declare type Options = {
    path: string;
    name: string;
    description?: string;
    type: "library" | "application" | "reactcomponent";
    authorName?: string;
    authorEmail?: string;
    /** Select the flavor of lockfiles you want. Also the nix file will install this packagemanager.
     * @default "npm"
     */
    packageManager?: PackageManager;
    /** Do not create git commits */
    disableGitCommits?: boolean;
    /** Do not create or modify a git repository. Set this, if the target dir is already inside a git repo. */
    disableGitRepo?: boolean;
    gitOrigin?: string;
    gitBranch?: string;
    logger?: Partial<Logger>;
};
export declare const createTypescriptThing: (options: Options) => Promise<void>;
export default createTypescriptThing;
