"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addHusky = void 0;
const addScriptToPackage_1 = require("../helpers/addScriptToPackage");
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const installPackage_1 = require("../helpers/installPackage");
const withStateLogger_1 = require("../helpers/withStateLogger");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
exports.addHusky = (0, withStateLogger_1.withStateLogger)({ id: "husky", completed: "Added git hooks with husky" }, (config) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, installPackage_1.installPackage)(config, ["husky@8.0.1", "pinst@3.0.0"]);
    yield (0, writeAndAddFile_1.writeAndAddFile)(config, ".husky/pre-commit", `#!/usr/bin/env sh
  . "$(dirname -- "$0")/_/husky.sh"
  
  FORCE_COLOR=1 "$(dirname -- "$0")/../node_modules/.bin/lint-staged" -c .lintstagedrc.json`, { executable: true });
    yield (0, addScriptToPackage_1.addScriptToPackage)(config, "postinstall", "husky install");
    yield (0, addScriptToPackage_1.addScriptToPackage)(config, "prepack", "pinst --disable");
    yield (0, addScriptToPackage_1.addScriptToPackage)(config, "postpack", "pinst --enable");
    yield (0, commitWithAuthor_1.commitWithAuthor)(config, "Install husky and enable pre-commmit hook");
}));
