"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addNixShell = void 0;
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const withStateLogger_1 = require("../helpers/withStateLogger");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
exports.addNixShell = (0, withStateLogger_1.withStateLogger)({ id: "nix shell", message: "Adding nix shell", completed: "Added nix shell" }, (config) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, writeAndAddFile_1.writeAndAddFile)(config, "flake.nix", generateNixFlake(config));
    yield (0, commitWithAuthor_1.commitWithAuthor)(config, "Add nix shell");
}));
const generateNixFlake = (config) => {
    return `{
  inputs = {
    nixpkgs.url =
      "github:nixos/nixpkgs?rev=07b207c5e9a47b640fe30861c9eedf419c38dce0";
    flake-utils.url =
      "github:numtide/flake-utils?rev=c0e246b9b83f637f4681389ecabcb2681b4f3af0";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.simpleFlake {
      inherit self nixpkgs;
      name = "Package name";
      shell = { pkgs }:
        pkgs.mkShell {
          buildInputs = with pkgs; [ nodejs ${config.packageManager === "yarn" ? "yarn" : config.packageManager === "pnpm" ? "nodePackages.pnpm" : ""} ];
          shellHook = ''
            export PATH="$(pwd)/node_modules/.bin:$PATH"
          '';
        };

    };
}`;
};
